Bazaar

Bazaar

 




Wiki Tools

  • Find Page
  • Recent Changes
  • Page History
  • Attachments

Revision 188 as of 2008-07-22 13:46:24

Clear message

Bazaar support for Subversion branches, working trees and repositories

Introduction

bzr-svn is a plugin that allows Bazaar direct access to Subversion repositories. It allows most bzr commands to work directly against Subversion repositories, as if you were using bzr with a native bzr repository.

The plugin can at the moment be used to commit to, pull from, merge from, push to and view logs of Subversion branches from Bazaar.

Features

The following features are currently present:

  • Connecting to remote Subversion repositories over all protocols supported by Subversion itself (at present: svn://, svn+ssh://, http:// (webdav), file://) as well as dump files.

    Checkouts, lightweight checkouts and branching works.

  • Integrates well with Bazaar.

  • Track Bazaar merges in Subversion. Merged revisions show up as ghosts.

  • Subversion working copies. Can be modified, queried (bzr status on a svn- native working copy created with svn co works) and committed from.

  • Committing to Subversion from Bazaar.

  • Push Bazaar revisions to Subversion.

  • Follow branch copies. Revision history is not truncated when a branch was copied in Subversion.

  • Efficiently uses network bandwidth.

  • Recognizes file metadata (executable bits, symbolic links).

  • 'svn-import' command with functionality similar to svn2bzr.

  • Ability to track merges done with SVK and write merges from SVK/Subversion branches in a format understandable by SVK.
  • Generates consistent file ids and revision ids. Two branches made using this plugin of the same Subversion branch will result in exactly the same Bazaar branch.
  • Handles complex operations in Subversion: committing to two branches at once, upgrading directories to branches, copies from early revisions, ...
  • Tested on Linux, Windows and Mac OS X.

Documentation

bzr-svn can be used through the regular Bazaar user interface, see the Bazaar Documentation Overview for documentation on that.

Some bzr-svn specific issues are answered by the FAQ.

The way Bazaar metadata is stored in Subversion and the other way around is specified in the mapping specification.

Support

Please use the regular Bazaar channels for support for questions about bzr-svn.

Limitations

Unsupported Subversion File Properties

Some Subversion properties can currently not be represented in Bazaar and are therefore ignored for the time being:

  • 'svn:ignore' is not imported. There should be a Repository.get_ignores(revid) call in Bazaar rather than a magic '.bzrignore' file. Spec at https://launchpad.net/products/bzr/+spec/new-ignore-rules
  • 'svn:mime-type'
  • 'svn:eol-style'. Requires eol support in Bazaar.
  • 'svn:keywords'. Requires keywords support in Bazaar. Spec at https://launchpad.net/products/bzr/+spec/bzr-keyword-expansion. #81463

Other features currently held back by Bazaars feature set:

Bazaar Commands

Most Bazaar commands should work fine with Subversion branches. The following commands at the moment do not:

  • bzr uncommit
  • bzr push --overwrite

Releases

  • 0.4.10 (works with Bazaar 1.4 and 1.5)
  • 0.4.9 (works with Bazaar 1.3)
  • 0.4.8 (works with Bazaar 1.2)
  • 0.4.7 (works with Bazaar 1.0 and 1.1)
  • 0.4.6 (works with Bazaar 1.0 and 1.1)
  • 0.4.5 (works with Bazaar 1.0 and higher)
  • 0.4.4 (works with Bazaar 0.92 and higher)
  • 0.4.3 (works with Bazaar 0.90 and higher)
  • 0.4.2 (works with Bazaar 0.90 and higher)
  • 0.4.1 (works with Bazaar 0.90 and higher)
  • 0.4.0 (works with Bazaar 0.19 and higher)
  • 0.3.5 (works with Bazaar 0.18 and higher)
  • 0.3.4 (works with Bazaar 0.17 and higher)
  • 0.3.3 (works with Bazaar 0.16 and higher)
  • 0.3.2 (works with Bazaar 0.15 and higher)
  • 0.3.1 (works with Bazaar 0.14 and higher)
  • 0.3 (works with Bazaar 0.14 and higher)
  • 0.2 (works with Bazaar 0.13 and higher)
  • 0.1 (works with Bazaar 0.8 and higher)

Requirements

Bazaar

You will need a recent version of Bazaar, usually the release of Bazaar released in the same month as the release of bzr-svn you are using. bzr-svn will warn if the Bazaar release used is too old or too new.

SQLite

If you are using Python 2.4, you will need to have the pysqlite module installed. Python 2.5 and higher have sqlite support built in.

Python-Subversion >= 1.5

The plugin requires a couple of fixes to the Python bindings for Subversion that are only available in Subversion 1.5 and higher. Subversion 1.5 has not been released yet, but packages with the appropriate patches applied to older versions are available for some platforms.

Building from source

Subversion 1.5 and 1.6 (trunk) contain the required fixes. To compile Subversion from trunk, run:

$ svn export http://svn.collab.net/repos/svn/trunk svn
$ ./autogen.sh --release
$ ./configure
$ make
$ make check-swig-py
$ sudo make install install-swig-py

Patches for Subversion 1.3.x and 1.4.x are also available:

To build a fixed version of Subversion's Python bindings using one of these patches, run:

$ wget http://subversion.tigris.org/downloads/subversion-1.4.3.tar.bz2
$ tar xvfj subversion-1.4.3.tar.bz2
$ cd subversion-1.4.3
$ patch -p1 < subversion-1.4.0-metze-python-bindings.patch
$ ./autogen.sh --release
$ ./configure
$ make
$ make check-swig-py
$ sudo make install install-swig-py

Please note that the patches against Subversion 1.3.2 and 1.4.0 don't include the fix for a major memory leak in python-subversion.

Windows Setup

An unofficial bzr-svn installer for Win32 as well as an unofficial, patched build of Python-Subversion for Windows can be found at http://d5190871.u44.websitesource.net/bzr/. This package can be used with the Python-based installer or the standalone installation of Bazaar.

Debian/Ubuntu

Debian/Ubuntu packages with the required fixes backported are available in Ubuntu since Edgy and Debian since Etch. You need the python-subversion and libsvn0 packages.

Fedora 9 (i386)

Fedora 9 (i386) users may obtain Subversion RPMs built with the patch from http://www.laserjock.us/files/fedora/ .

GoboLinux

GoboLinux includes a recipe for bzr-svn.

Mac OS X
From Source

To install on OS X Leopard do something like the following. Note: If you have MacPython installed, you may encounter problems when building BzrSvn.

# Install the latest stable Bazaar (if you didn't already)
sudo easy_install -U paramiko pycrypto bzr

# Install the bzr_svn plugin
mkdir ~/.bazaar ~/.bazaar/plugins
cd ~/.bazaar/plugins
rm -rf svn
bzr checkout --lightweight \
  http://people.samba.org/bzr/jelmer/bzr-svn/stable svn

make

If the above instructions don't work on Tiger, try the following:

# Install the latest stable Bazaar (if you didn't already)
sudo easy_install -U paramiko pycrypto bzr

# Compile Subversion 1.5 (for better python support)
cd /tmp
rm -rf svn
svn export http://svn.collab.net/repos/svn/trunk svn
cd svn
curl http://www.webdav.org/neon/neon-0.27.2.tar.gz | tar xz
ln -sf neon-0.27.2 neon
./autogen.sh
./configure --without-apxs --with-ssl --prefix=$HOME/.bazaar/svn
make install install-swig-py
cd ..

# Install the bzr_svn plugin
mkdir ~/.bazaar ~/.bazaar/plugins
cd ~/.bazaar/plugins
rm -rf svn
bzr checkout --lightweight \
  http://people.samba.org/bzr/jelmer/bzr-svn/stable svn
# The following is a temporary patch - it will core-dump without it,
# but disables any support for authenticating
perl -p -i -e 's/(providers \+\= auth\.Subversion)/\#$1/g' svn/transport.py
perl -p -i -e 's/(providers \+\= \[auth\.get)/\#$1/g' svn/transport.py

# Setup your profile to recognize subversion 1.5
echo >> ~/.profile << \EOF
alias bzr="DYLD_LIBRARY_PATH=$HOME/.bazaar/svn/lib \
PYTHONPATH=$HOME/.bazaar/svn/lib/svn-python \
bzr"
EOF
. ~/.profile

# Test bzr + svn w/ ssl
cd /tmp
rm -rf test
bzr branch https://svn.collab.net/repos/svn/trunk test
  • If you updated XCode to 2.5, your libtool is broken. Installing libtool from macports solve this problem.
Using (release candidate) installer

Download the latest Subversion DMG from: http://svnbinaries.open.collab.net/servlets/ProjectDocumentList

After installing, add the svn-python bindings to your Python2.5 installation

# Tiger
echo "/opt/subversion-1.5.x/lib/svn-python/" > /Library/Frameworks/Python.framework/Versions/2.5/lib/python2.5/site-packages/subversion.pth

# Leopard
echo "/opt/subversion-1.5.x/lib/svn-python/" > /System/Library/Frameworks/Python.framework/Versions/2.5/lib/python2.5/site-packages/subversion.pth

Install the bzr_svn plugin following the instructions in the From Source section (a DMG is coming soon ;) )

bzr-rebase

In order to be able to use the svn-upgrade command (for those who used versions of bzr-svn older than 0.4.0), you will need the bzr-rebase plugin.

Packages

Debian/Ubuntu packages are available from Jelmer's Debian repository.

Ubuntu's in-development release and Debian sid usually also contain the latest release.

OpenSuse packages created by Michael Wolf are available from http://download.opensuse.org/repositories/home:/maw:/bzr/

Installation instructions for Fedora/RedHat are on https://planning.acm.org/hq/documentation/version-control/installing-bzr-svn

An unofficial Gentoo overlay containing the patches for Subversion versions 1.3 and 1.4, plus a bzr-svn ebuild are hosted on launchpad at https://launchpad.net/bzr-gentoo-overlay/.

Bugs

Please file bug reports in launchpad. The product URL for bzr-svn is https://launchpad.net/bzr-svn/.

Development

Branches

Unit testing

To run the bzr-svn testsuite, simply run 'bzr selftest svn'

Credits

bzr-svn was written by JelmerVernooij with the help from various other people. See the AUTHORS file in the source distribution for a list.